#ifndef __DB__DB_OBJECT_PH__
#define __DB__DB_OBJECT_PH__

DbObject DbObjectFind (char* name);
DbObject DbObjectFindInPath (char* name, char* path_name);
/* void DbObjectCleanup (); */
DbObject DbObjectNewInPath (DbType type, char* name, char* path_name);
int DbObjectInstall (DbObject object);
int DbObjectInstallInPath (DbObject object, char* path_name);
void DbObjectRemove (DbObject object);
/* static void DbObjectErase (DbObject object); */
void DbObjectClear (DbObject object);
void DbObjectInitialize (DbObject object, DbType type);
void DbObjectDestroy (DbObject object);
/* void DbObjectsDestroy (CLList objects); */
/* static void DbObjectDelete (DbObject object); */
void DbObjectSetOwner (DbObject object, char* owner);
DbType DbObjectGetType (DbObject object);
char* DbObjectGetName (DbObject object);
char* DbObjectGetOwner (DbObject object);
DbVersioningOption DbObjectGetVersioningOption (DbObject object);
void DbObjectSetVersioningOption (DbObject object, DbVersioningOption option);
char* DbObjectGetPathName (DbObject object);
/* DbTypeIterator DbObjectGiveInputIterator (DbObject object); */
DbTypeIterator DbObjectGiveOutputIterator (DbObject object);
void DbObjectVisit (DbObject object, DbVisitor visitor);
void* DbObjectGetAddress (DbObject object, DbType type);
char* DbCharObjectGetAddress (DbObject object);
short* DbShortObjectGetAddress (DbObject object);
int* DbIntObjectGetAddress (DbObject object);
unsigned int* DbHexaObjectGetAddress (DbObject object);
float* DbFloatObjectGetAddress (DbObject object);
double* DbDoubleObjectGetAddress (DbObject object);
DbString* DbStringObjectGetAddress (DbObject object);
DbVector* DbVectorObjectGetAddress (DbObject object);
DbMatrix* DbMatrixObjectGetAddress (DbObject object);
void* DbStructureObjectGetAddress (DbObject object);
DbReference* DbReferenceObjectGetAddress (DbObject object);

#endif /* __DB__DB_OBJECT_PH__ */
