#! /bin/sh
#
# Initialize the temporary CVS files used in Db branch management
#
# Make :
#         CVS/Entries      (empty)
#         CVS/Root         ($CVSROOT)
#         CVS/Repository   ($CVSROOT/Objects/"OBJECTPATH"  
#
myname=`basename $0`
#
case "$#" in
  0) object_path=""
     ;;
  1) object_path="/$1"
     shift
     ;;
  *) echo "Usage: ${myname} [OBJECTPATH]" 1>&2 
     exit 1
     ;;
esac

set -x

Db_tmp='.db_tmp_for_branch'

Entries=${DBOBJECTSROOT}/${Db_tmp}/CVS/Entries
Root=${DBOBJECTSROOT}/${Db_tmp}/CVS/Root
Repository=${DBOBJECTSROOT}/${Db_tmp}/CVS/Repository
#

if test ! -d ${Db_tmp} ; then
  mkdir ${DBOBJECTSROOT}/$Db_tmp
fi

rm -f ${DBOBJECTSROOT}/${Db_tmp}/*.db

if test ! -d ${DBOBJECTSROOT}/${Db_tmp}/CVS ; then
  mkdir ${DBOBJECTSROOT}/$Db_tmp/CVS
fi

#

if test -f ${Entries} ; then
  rm ${Entries}
fi

touch ${Entries}

#

if test ! -f ${Root} ; then
  cat << END >> ${Root}
${DBCVSROOT}
END
fi

#

if test -f ${Repository} ; then
  rm ${Repository}
fi

cat << END >> ${Repository}
${DBCVSROOT}/Objects${object_path}
END

