#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <Db.h>

/*---------------------------------------------------------------------------*/
DbMatrix* DbMatrixReferenceGetAddress (DbReference* reference)
/*---------------------------------------------------------------------------*/
{
  DbObject object;
  DbMatrix* result;

  object = DbReferenceGetObject (reference);

  if (!DbTypeIsMatrix (DbObjectGetType (object)))
    {
      DbSetErrorInfo (DbErrorTypeMismatch, "DbMatrixReferenceGetAddress>");
      return (NULL);
    }

  result = (DbMatrix*) DbMatrixObjectGetAddress (object);
  return (result);
}

/*---------------------------------------------------------------------------*/
DbMatrix* DbMatrixObjectLoad (char* name)
/*---------------------------------------------------------------------------*/
{
  DbObject object;

  object = DbLoadObject (name);
  if (DbGetError () != DbErrorOk) return (NULL);

  if (!DbTypeIsMatrix (DbObjectGetType (object)))
    {
      DbSetErrorInfo (DbErrorTypeMismatch, "DbMatrixObjectLoad>");
      return (NULL);
    }

  return ((DbMatrix*) DbMatrixObjectGetAddress (object));
}


/*---------------------------------------------------------------------------*/
DbMatrix* DbMatrixObjectLoadByTag (char* name, char* tag)
/*---------------------------------------------------------------------------*/
{
  DbObject object;

  object = DbLoadObjectByTag (name, tag);
  if (DbGetError () != DbErrorOk) return (NULL);

  if (!DbTypeIsMatrix (DbObjectGetType (object)))
    {
      DbSetErrorInfo (DbErrorTypeMismatch, "DbMatrixObjectLoad>");
      return (NULL);
    }

  return ((DbMatrix*) DbMatrixObjectGetAddress (object));
}

/*---------------------------------------------------------------------------*/
DbMatrix* DbMatrixObjectLoadByDate (char* name, char* date)
/*---------------------------------------------------------------------------*/
{
  DbObject object;

  object = DbLoadObjectByDate (name, date);
  if (DbGetError () != DbErrorOk) return (NULL);

  if (!DbTypeIsMatrix (DbObjectGetType (object)))
    {
      DbSetErrorInfo (DbErrorTypeMismatch, "DbMatrixObjectLoad>");
      return (NULL);
    }

  return ((DbMatrix*) DbMatrixObjectGetAddress (object));
}
