#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <Db.h>

/*---------------------------------------------------------------------------*/
DbVector* DbVectorReferenceGetAddress (DbReference* reference)
/*---------------------------------------------------------------------------*/
{
  DbObject object;
  DbVector* result;

  object = DbReferenceGetObject (reference);

  if (!DbTypeIsVector (DbObjectGetType (object)))
    {
      DbSetErrorInfo (DbErrorTypeMismatch, "DbVectorReferenceGetAddress>");
      return (NULL);
    }

  result = (DbVector*) DbVectorObjectGetAddress (object);
  return (result);
}

/*---------------------------------------------------------------------------*/
DbVector* DbVectorObjectLoad (char* name)
/*---------------------------------------------------------------------------*/
{
  DbObject object;

  object = DbLoadObject (name);
  if (DbGetError () != DbErrorOk) return (NULL);

  if (!DbTypeIsVector (DbObjectGetType (object)))
    {
      DbSetErrorInfo (DbErrorTypeMismatch, "DbVectorObjectLoad>");
      return (NULL);
    }

  return ((DbVector*) DbVectorObjectGetAddress (object));
}

/*---------------------------------------------------------------------------*/
DbVector* DbVectorObjectLoadByTag (char* name, char* tag)
/*---------------------------------------------------------------------------*/
{
  DbObject object;

  object = DbLoadObjectByTag (name, tag);
  if (DbGetError () != DbErrorOk) return (NULL);

  if (!DbTypeIsVector (DbObjectGetType (object)))
    {
      DbSetErrorInfo (DbErrorTypeMismatch, "DbVectorObjectLoad>");
      return (NULL);
    }

  return ((DbVector*) DbVectorObjectGetAddress (object));
}

/*---------------------------------------------------------------------------*/
DbVector* DbVectorObjectLoadByDate (char* name, char* date)
/*---------------------------------------------------------------------------*/
{
  DbObject object;

  object = DbLoadObjectByDate (name, date);
  if (DbGetError () != DbErrorOk) return (NULL);

  if (!DbTypeIsVector (DbObjectGetType (object)))
    {
      DbSetErrorInfo (DbErrorTypeMismatch, "DbVectorObjectLoad>");
      return (NULL);
    }

  return ((DbVector*) DbVectorObjectGetAddress (object));
}
